Subject: Re: [PATCH net-next-2.6 v4 2/2] hfsc: add link layer overhead adaption

From: Patrick McHardy <[email-masked]>
Date: Tue, 15 Jul 2008 12:55:25 +0200

Jussi Kivilinna wrote:
> Quoting "Patrick McHardy" <[email-masked]>:
> 
>>
>> I thought you were going to make this a generic qdisc feature.
>> Why is configuration still qdisc specific?
>>
> 
> I was thinking keeping scope of this patch within hfsc, as done with 
> rest of rate table qdiscs. So it would be better to have they all to use 
> generic size table instead of duplicating rtab code.

Well, to use this feature consistently (meaning sizes propagate
down to inner qdiscs) it needs to be a generic feature.

>> I was thinking of something like this:
>>
>> - add generic attributes for configuring size tables for any
>>   qdisc, handle those in sch_api
>>
>> - add qdisc_enqueue() wrapper that calculates the size and
>>   stores it in skb->cb, convert direct calls of sch->enqueue
>>   to use it
>>
>> - change direct uses of skb->len to use the size from the cb
>>
>> The second step might need a bit more thought to make sure
>> qdiscs don't get confused when the dequeued packet is larger
>> than the enqueued one, but I think they usually don't care.
>>
> 
> I guess I'll start over using your size table patch as base then.

I'm not sure that part is correct in my patch :)